Index: LMDZ6/branches/LMDZ-tracers/libf/phylmd/oasis.F90
===================================================================
--- LMDZ6/branches/LMDZ-tracers/libf/phylmd/oasis.F90	(revision 3725)
+++ LMDZ6/branches/LMDZ-tracers/libf/phylmd/oasis.F90	(revision 3851)
@@ -59,7 +59,10 @@
   INTEGER, PARAMETER :: ids_qraiic = 28
   INTEGER, PARAMETER :: ids_qsnoic = 29
-  INTEGER, PARAMETER :: maxsend    = 29  ! Maximum number of fields to send
+  INTEGER, PARAMETER :: ids_delta_sst = 30, ids_delta_sal = 31
+  
+  INTEGER, PARAMETER :: maxsend    = 31  ! Maximum number of fields to send
   
   ! Id for fields received from ocean
+
   INTEGER, PARAMETER :: idr_sisutw = 1
   INTEGER, PARAMETER :: idr_icecov = 2
@@ -70,5 +73,9 @@
   INTEGER, PARAMETER :: idr_curenz = 7
   INTEGER, PARAMETER :: idr_oceco2 = 8
-  INTEGER, PARAMETER :: maxrecv    = 8  ! Maximum number of fields to receive
+
+  INTEGER, PARAMETER :: idr_sss = 9
+  ! bulk salinity of the surface layer of the ocean, in ppt
+
+  INTEGER, PARAMETER :: maxrecv    = 9  ! Maximum number of fields to receive
   
 
@@ -110,6 +117,5 @@
     USE geometry_mod, ONLY: ind_cell_glo                    
     USE mod_phys_lmdz_mpi_data, ONLY: klon_mpi_para_nb
-    
-
+    use config_ocean_skin_m, only: activate_ocean_skin
 
 ! Local variables
@@ -183,4 +189,11 @@
     infosend(ids_calvin)%action = .TRUE. ; infosend(ids_calvin)%name = 'COCALVIN'
     
+    if (activate_ocean_skin == 2) then
+       infosend(ids_delta_sst)%action = .TRUE.
+       infosend(ids_delta_sst)%name = 'CODELSST'
+       infosend(ids_delta_sal)%action = .TRUE.
+       infosend(ids_delta_sal)%name = 'CODELSSS'
+    end if
+           
     IF (version_ocean=='nemo') THEN
         infosend(ids_shftot)%action = .TRUE. ; infosend(ids_shftot)%name = 'COQSRMIX'
@@ -219,4 +232,9 @@
    inforecv(idr_icealw)%action = .TRUE. ; inforecv(idr_icealw)%name = 'SIICEALW'
    inforecv(idr_icetem)%action = .TRUE. ; inforecv(idr_icetem)%name = 'SIICTEMW'
+
+   if (activate_ocean_skin >= 1) then
+      inforecv(idr_sss)%action = .TRUE.
+      inforecv(idr_sss)%name = 'SISUSALW'
+   end if
    
    IF (cpl_current ) THEN
Index: LMDZ6/branches/LMDZ-tracers/libf/phylmd/ocean_cpl_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ-tracers/libf/phylmd/ocean_cpl_mod.F90	(revision 3725)
+++ LMDZ6/branches/LMDZ-tracers/libf/phylmd/ocean_cpl_mod.F90	(revision 3851)
@@ -52,8 +52,9 @@
        AcoefH, AcoefQ, BcoefH, BcoefQ, &
        AcoefU, AcoefV, BcoefU, BcoefV, &
-       ps, u1, v1, gustiness, &
+       ps, u1, v1, gustiness, tsurf_in, &
        radsol, snow, agesno, &
        qsurf, evap, fluxsens, fluxlat, flux_u1, flux_v1, &
-       tsurf_new, dflux_s, dflux_l)
+       tsurf_new, dflux_s, dflux_l, sens_prec_liq, sss, delta_sal, rhoa, &
+       delta_sst)
 
 !
@@ -63,9 +64,10 @@
 !
     USE dimphy,           ONLY : klon
-    USE cpl_mod
     USE calcul_fluxs_mod
     USE indice_sol_mod
     USE phys_output_var_mod, ONLY : sens_prec_liq_o, sens_prec_sol_o, lat_prec_liq_o, lat_prec_sol_o
-    USE cpl_mod,             ONLY : gath2cpl
+    USE cpl_mod, ONLY : gath2cpl, cpl_receive_ocean_fields, &
+         cpl_send_ocean_fields
+    use config_ocean_skin_m, only: activate_ocean_skin
 
     INCLUDE "YOMCST.h"
@@ -90,4 +92,14 @@
     REAL, DIMENSION(klon), INTENT(IN)        :: ps
     REAL, DIMENSION(klon), INTENT(IN)        :: u1, v1, gustiness
+    REAL, INTENT(IN) :: tsurf_in(:) ! (klon)
+
+    real, intent(in):: delta_sal(:) ! (knon)
+    ! ocean-air interface salinity minus bulk salinity, in ppt
+
+    real, intent(in):: rhoa(:) ! (knon) density of moist air  (kg / m3)
+
+    REAL, intent(in):: delta_sst(:) ! (knon)
+    ! Ocean-air interface temperature minus bulk SST, in K. Defined
+    ! only if activate_ocean_skin >= 1.
 
 ! In/Output arguments
@@ -104,4 +116,8 @@
     REAL, DIMENSION(klon), INTENT(OUT)       :: tsurf_new
     REAL, DIMENSION(klon), INTENT(OUT)       :: dflux_s, dflux_l      
+    REAL, intent(out):: sens_prec_liq(:) ! (knon)
+
+    REAL, INTENT(OUT):: sss(:) ! (klon)
+    ! bulk salinity of the surface layer of the ocean, in ppt
   
 
@@ -116,5 +132,5 @@
     REAL, DIMENSION(klon) :: u1_lay, v1_lay
     LOGICAL               :: check=.FALSE.
-    REAL, DIMENSION(klon) :: sens_prec_liq, sens_prec_sol    
+    REAL sens_prec_sol(knon)  
     REAL, DIMENSION(klon) :: lat_prec_liq, lat_prec_sol    
 
@@ -128,5 +144,6 @@
 !
 !****************************************************************************************
-    CALL cpl_receive_ocean_fields(knon, knindex, tsurf_cpl, u0_cpl, v0_cpl)
+    CALL cpl_receive_ocean_fields(knon, knindex, tsurf_cpl, u0_cpl, v0_cpl, &
+         sss)
 
 !****************************************************************************************
@@ -138,5 +155,5 @@
     dif_grnd = 0.
     agesno(:) = 0.
-    sens_prec_liq = 0.; sens_prec_sol = 0.; lat_prec_liq = 0.; lat_prec_sol = 0.
+    lat_prec_liq = 0.; lat_prec_sol = 0.
     
 
@@ -147,10 +164,20 @@
 
     CALL calcul_fluxs(knon, is_oce, dtime, &
-         tsurf_cpl, p1lay, cal, beta, cdragh, cdragq, ps, &
+         merge(tsurf_in, tsurf_cpl, activate_ocean_skin == 2), p1lay, cal, &
+         beta, cdragh, cdragq, ps, &
          precip_rain, precip_snow, snow, qsurf,  &
          radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, gustiness, &
          f_qsat_oce,AcoefH, AcoefQ, BcoefH, BcoefQ, &
          tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l, &
-         sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
+         sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol, rhoa)
+
+    if (activate_ocean_skin == 2) then
+       ! tsurf_new was set to tsurf_in in calcul_flux, correct it to
+       ! the new bulk SST tsurf_cpl:
+       tsurf_new = tsurf_cpl
+    end if
+
+    ! assertion: tsurf_new == tsurf_cpl
+    
     do j = 1, knon
       i = knindex(j)
@@ -189,9 +216,8 @@
 !****************************************************************************************
 
-    CALL cpl_send_ocean_fields(itime, knon, knindex, &
-         swnet, lwnet, fluxlat, fluxsens, &
-         precip_rain, precip_snow, evap, tsurf_new, fder_new, alb1, flux_u1, flux_v1, windsp,&
-         sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
-    
+    CALL cpl_send_ocean_fields(itime, knon, knindex, swnet, lwnet, fluxlat, &
+         fluxsens, precip_rain, precip_snow, evap, tsurf_new, fder_new, alb1, &
+         flux_u1, flux_v1, windsp, sens_prec_liq, sens_prec_sol, lat_prec_liq, &
+         lat_prec_sol, delta_sst, delta_sal)
 
   END SUBROUTINE ocean_cpl_noice
@@ -210,5 +236,5 @@
        radsol, snow, qsurf, &
        alb1_new, alb2_new, evap, fluxsens, fluxlat, flux_u1, flux_v1, &
-       tsurf_new, dflux_s, dflux_l)
+       tsurf_new, dflux_s, dflux_l, rhoa)
 !
 ! This subroutine treats the ocean where there is ice. The subroutine first receives 
@@ -245,4 +271,5 @@
     REAL, DIMENSION(klon), INTENT(IN)        :: u1, v1, gustiness
     REAL, DIMENSION(klon,nbsrf), INTENT(IN)  :: pctsrf
+    real, intent(in):: rhoa(:) ! (knon) density of moist air  (kg / m3)
 
 ! In/output arguments
@@ -272,5 +299,5 @@
     REAL, DIMENSION(klon)   :: u0, v0
     REAL, DIMENSION(klon)   :: u1_lay, v1_lay
-    REAL, DIMENSION(klon) :: sens_prec_liq, sens_prec_sol    
+    REAL sens_prec_liq(knon), sens_prec_sol(knon)   
     REAL, DIMENSION(klon) :: lat_prec_liq, lat_prec_sol    
 
@@ -280,5 +307,5 @@
     IF (check) WRITE(*,*)'Entering surface_seaice, knon=',knon 
 
-    sens_prec_liq = 0.; sens_prec_sol = 0.; lat_prec_liq = 0.; lat_prec_sol = 0.
+    lat_prec_liq = 0.; lat_prec_sol = 0.
 
 !****************************************************************************************
@@ -313,5 +340,5 @@
          f_qsat_oce,AcoefH, AcoefQ, BcoefH, BcoefQ, &
          tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l, &
-         sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
+         sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol, rhoa)
     do j = 1, knon
       i = knindex(j)
Index: LMDZ6/branches/LMDZ-tracers/libf/phylmd/ocean_forced_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ-tracers/libf/phylmd/ocean_forced_mod.F90	(revision 3725)
+++ LMDZ6/branches/LMDZ-tracers/libf/phylmd/ocean_forced_mod.F90	(revision 3851)
@@ -19,8 +19,8 @@
        AcoefH, AcoefQ, BcoefH, BcoefQ, &
        AcoefU, AcoefV, BcoefU, BcoefV, &
-       ps, u1, v1, gustiness, &
+       ps, u1, v1, gustiness, tsurf_in, &
        radsol, snow, agesno, & 
        qsurf, evap, fluxsens, fluxlat, flux_u1, flux_v1, &
-       tsurf_new, dflux_s, dflux_l)
+       tsurf_new, dflux_s, dflux_l, sens_prec_liq, rhoa)
 !
 ! This subroutine treats the "open ocean", all grid points that are not entierly covered
@@ -35,8 +35,9 @@
     USE indice_sol_mod
     USE phys_output_var_mod, ONLY : sens_prec_liq_o, sens_prec_sol_o, lat_prec_liq_o, lat_prec_sol_o
+    use config_ocean_skin_m, only: activate_ocean_skin
 
     INCLUDE "YOMCST.h"
     INCLUDE "clesphys.h"
-
+    INCLUDE "flux_arp.h"
 
 ! Input arguments
@@ -53,4 +54,6 @@
     REAL, DIMENSION(klon), INTENT(IN)        :: ps
     REAL, DIMENSION(klon), INTENT(IN)        :: u1, v1, gustiness
+    REAL, DIMENSION(klon), INTENT(IN)        :: tsurf_in
+    real, intent(in):: rhoa(:) ! (knon) density of moist air  (kg / m3)
 
 ! In/Output arguments
@@ -67,4 +70,5 @@
     REAL, DIMENSION(klon), INTENT(OUT)       :: tsurf_new
     REAL, DIMENSION(klon), INTENT(OUT)       :: dflux_s, dflux_l
+    REAL, intent(out):: sens_prec_liq(:) ! (knon)
 
 ! Local variables
@@ -76,5 +80,5 @@
     REAL, DIMENSION(klon)       :: u1_lay, v1_lay
     LOGICAL                     :: check=.FALSE.
-    REAL, DIMENSION(klon) :: sens_prec_liq, sens_prec_sol    
+    REAL sens_prec_sol(knon) 
     REAL, DIMENSION(klon) :: lat_prec_liq, lat_prec_sol    
 
@@ -92,5 +96,10 @@
 !!jyg    if (knon.eq.1) then ! single-column model
     if (klon_glo.eq.1) then ! single-column model
-      CALL read_tsurf1d(knon,tsurf_lim) ! new
+      ! EV: now surface Tin flux_arp.h
+      !CALL read_tsurf1d(knon,tsurf_lim) ! new
+       DO i = 1, knon
+        tsurf_lim(i) = tg
+       ENDDO
+
     else ! GCM
       CALL limit_read_sst(knon,knindex,tsurf_lim)
@@ -104,10 +113,18 @@
 !****************************************************************************************
 ! Set some variables for calcul_fluxs
-    cal = 0.
-    beta = 1.
-    dif_grnd = 0.
+    !cal = 0.
+    !beta = 1.
+    !dif_grnd = 0.
+    
+    
+    ! EV: use calbeta to calculate beta
+    ! Need to initialize qsurf for calbeta but it is not modified by this routine
+    qsurf(:)=0.
+    CALL calbeta(dtime, is_oce, knon, snow, qsurf, beta, cal, dif_grnd)
+
+
     alb_neig(:) = 0.
     agesno(:) = 0.
-    sens_prec_liq = 0.; sens_prec_sol = 0.; lat_prec_liq = 0.; lat_prec_sol = 0.
+    lat_prec_liq = 0.; lat_prec_sol = 0.
 
 ! Suppose zero surface speed
@@ -119,10 +136,12 @@
 ! Calcul de tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l and qsurf
     CALL calcul_fluxs(knon, is_oce, dtime, &
-         tsurf_lim, p1lay, cal, beta, cdragh, cdragq, ps, &
+         merge(tsurf_in, tsurf_lim, activate_ocean_skin == 2), p1lay, cal, &
+         beta, cdragh, cdragq, ps, &
          precip_rain, precip_snow, snow, qsurf,  &
          radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, gustiness, &
          f_qsat_oce,AcoefH, AcoefQ, BcoefH, BcoefQ, &
          tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l, &
-         sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
+         sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol, rhoa)
+    if (activate_ocean_skin == 2) tsurf_new = tsurf_lim
 
     do j = 1, knon
@@ -154,5 +173,5 @@
        radsol, snow, qsol, agesno, tsoil, &
        qsurf, alb1_new, alb2_new, evap, fluxsens, fluxlat, flux_u1, flux_v1, &
-       tsurf_new, dflux_s, dflux_l)
+       tsurf_new, dflux_s, dflux_l, rhoa)
 !
 ! This subroutine treats the ocean where there is ice. 
@@ -168,8 +187,9 @@
     USE phys_output_var_mod, ONLY : sens_prec_liq_o, sens_prec_sol_o, lat_prec_liq_o, lat_prec_sol_o
 
-!    INCLUDE "indicesol.h"
+!   INCLUDE "indicesol.h"
     INCLUDE "dimsoil.h"
     INCLUDE "YOMCST.h"
     INCLUDE "clesphys.h"
+    INCLUDE "flux_arp.h"
 
 ! Input arguments
@@ -187,4 +207,5 @@
     REAL, DIMENSION(klon), INTENT(IN)    :: ps
     REAL, DIMENSION(klon), INTENT(IN)    :: u1, v1, gustiness
+    real, intent(in):: rhoa(:) ! (knon) density of moist air  (kg / m3)
 
 ! In/Output arguments
@@ -216,5 +237,5 @@
     REAL, DIMENSION(klon)       :: u0, v0
     REAL, DIMENSION(klon)       :: u1_lay, v1_lay
-    REAL, DIMENSION(klon)       :: sens_prec_liq, sens_prec_sol    
+    REAL sens_prec_liq(knon), sens_prec_sol (knon)   
     REAL, DIMENSION(klon)       :: lat_prec_liq, lat_prec_sol    
 
@@ -233,5 +254,5 @@
     tsurf_tmp(:) = tsurf_in(:)
 
-! calculate the parameters cal, beta, capsol and dif_grnd
+! calculate the parameters cal, beta, capsol and dif_grnd and then recalculate cal
     CALL calbeta(dtime, is_sic, knon, snow, qsol, beta, capsol, dif_grnd)
 
@@ -249,6 +270,6 @@
     ENDIF
 
-    beta = 1.0
-    sens_prec_liq = 0.; sens_prec_sol = 0.; lat_prec_liq = 0.; lat_prec_sol = 0.
+!    beta = 1.0
+    lat_prec_liq = 0.; lat_prec_sol = 0.
 
 ! Suppose zero surface speed
@@ -263,5 +284,5 @@
          f_qsat_oce,AcoefH, AcoefQ, BcoefH, BcoefQ, &
          tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l, &
-         sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
+         sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol, rhoa)
     do j = 1, knon
       i = knindex(j)
@@ -307,27 +328,26 @@
 ! 1D case
 !************************************************************************
-  SUBROUTINE read_tsurf1d(knon,sst_out)
-
+!  SUBROUTINE read_tsurf1d(knon,sst_out)
+!
 ! This subroutine specifies the surface temperature to be used in 1D simulations
-
-      USE dimphy, ONLY : klon
-
-      INTEGER, INTENT(IN)                  :: knon     ! nomber of points on compressed grid
-      REAL, DIMENSION(klon), INTENT(OUT)   :: sst_out  ! tsurf used to force the single-column model
-
-       INTEGER :: i
+!
+!      USE dimphy, ONLY : klon
+!
+!      INTEGER, INTENT(IN)                  :: knon     ! nomber of points on compressed grid
+!      REAL, DIMENSION(klon), INTENT(OUT)   :: sst_out  ! tsurf used to force the single-column model
+!
+!       INTEGER :: i
 ! COMMON defined in lmdz1d.F:
-       real ts_cur
-       common /sst_forcing/ts_cur
-
-       DO i = 1, knon
-        sst_out(i) = ts_cur
-       ENDDO
-
-      END SUBROUTINE read_tsurf1d
-
+!       real ts_cur
+!       common /sst_forcing/ts_cur
+!
+!       DO i = 1, knon
+!        sst_out(i) = ts_cur
+!       ENDDO
+!
+!      END SUBROUTINE read_tsurf1d
+!
 !
 !************************************************************************
-!
 END MODULE ocean_forced_mod
 
Index: LMDZ6/branches/LMDZ-tracers/libf/phylmd/ocean_slab_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ-tracers/libf/phylmd/ocean_slab_mod.F90	(revision 3725)
+++ LMDZ6/branches/LMDZ-tracers/libf/phylmd/ocean_slab_mod.F90	(revision 3851)
@@ -421,7 +421,11 @@
 !    
 !****************************************************************************************
-    cal(:)      = 0. ! infinite thermal inertia
-    beta(:)     = 1. ! wet surface
-    dif_grnd(:) = 0. ! no diffusion into ground
+    !cal(:)      = 0. ! infinite thermal inertia
+    !beta(:)     = 1. ! wet surface
+    !dif_grnd(:) = 0. ! no diffusion into ground
+    ! EV: use calbeta
+    CALL calbeta(dtime, is_oce, knon, snow,qsurf, beta, cal, dif_grnd)
+
+
     
 ! Suppose zero surface speed
@@ -742,6 +746,10 @@
 ! set beta, cal, compute conduction fluxes inside ice/snow 
     slab_bilg(:)=0.
-    dif_grnd(:)=0.
-    beta(:) = 1.
+    !dif_grnd(:)=0.
+    !beta(:) = 1.
+    ! EV: use calbeta to calculate beta and then recalculate properly cal
+    CALL calbeta(dtime, is_sic, knon, snow, qsol, beta, cal, dif_grnd)
+
+
     DO i=1,knon
     ki=knindex(i)
